#include <stdio.h>
#include <setjmp.h>

jmp_buf jb; /* jump buffer to hold context */

int compute(int x, int y); /* declare compute function */
void error_handler(void); /*error handler*/

int main(int argc, char **argv) {
   int x = 10;
   int y = 1;
   int r;
   if(setjmp(jb) == 0) {
      r = compute(x, y);
      fprintf(stdout, "compute(%d, %d) = %d", x, y, r);
      return 0;
   } else {
      error_handler();
      return -1;
   }
}

int compute(int x, int y) {
   int error = 0;
   if(y == 0) {
      error = 1;
   } 
   if(error != 0) {
      longjmp(jb, 1);
   } else {
      x = (x + y * 2);
      return x / y;
   }
}

void error_handler(void)  {
   fprintf(stderr, "Error: division by zero!\n");
}
